<?php
if ( ! defined( 'ABSPATH' ) ) {
	die( '-1' );
}

/**
 * Shortcode attributes
 * @var $atts
 * @var $el_class
 * @var $css
 * @var $el_id
 * @var $equal_height
 * @var $content_placement
 * @var $content - shortcode content
 * Shortcode class
 * @var WPBakeryShortCode_Vc_Row_Inner $this
 */
$el_class = $equal_height = $content_placement = $css = $el_id = '';
$disable_element = '';
$output = $after_output = '';
$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( $atts );

$el_class = $this->getExtraClass( $el_class );
$css_classes = array(
	'vc_row',
	'wpb_row',
	// deprecated
	'vc_inner',
	'vc_row-fluid',
	$el_class,
	vc_shortcode_custom_css_class( $css ),
);
if ( 'yes' === $disable_element ) {
	if ( vc_is_page_editable() ) {
		$css_classes[] = 'vc_hidden-lg vc_hidden-xs vc_hidden-sm vc_hidden-md';
	} else {
		return '';
	}
}

if ( vc_shortcode_custom_css_has_property( $css, array(
	'border',
	'background',
) ) ) {
	$css_classes[] = 'vc_row-has-fill';
}

if ( ! empty( $atts['gap'] ) ) {
	$css_classes[] = 'vc_column-gap-' . $atts['gap'];
}

if ( ! empty( $equal_height ) ) {
	$flex_row = true;
	$css_classes[] = 'vc_row-o-equal-height';
}

if ( ! empty( $atts['rtl_reverse'] ) ) {
	$css_classes[] = 'vc_rtl-columns-reverse';
}

if ( ! empty( $content_placement ) ) {
	$flex_row = true;
	$css_classes[] = 'vc_row-o-content-' . $content_placement;
}

if ( ! empty( $flex_row ) ) {
	$css_classes[] = 'vc_row-flex';
}

if ( ! empty( $column_inner_spacing ) ) {
	$css_classes[] = 'vc-custom-col-spacing-'. $column_inner_spacing;
}

$wrapper_attributes = array();
// build attributes for wrapper
if ( ! empty( $el_id ) ) {
	$wrapper_attributes[] = 'id="' . esc_attr( $el_id ) . '"';
}

// Custom Background
if ( $inner_bg_custom ) {
	$css_classes[] = 'position-relative';

	$inner_bg_css = $inner_bg_cls = '';
	$inner_bg_cls .= $inner_bg_custom;

	if ( $inner_bg_color ) $inner_bg_css .= 'background-color:' . $inner_bg_color . ';';
	if ( $inner_bg_rounded ) $inner_bg_css .= 'border-radius:' . $inner_bg_rounded . ';';
	if ( $inner_bg_shadow ) $inner_bg_css .= 'box-shadow:' . $inner_bg_shadow . ';';
	if ( $inner_bg_image) {
		$inner_bg_css .= 'background-image:url('. esc_url( wp_get_attachment_image_src( $inner_bg_image, 'full' )[0] ) .');';
		if ( $inner_bg_position ) $inner_bg_css .= 'background-position:'. $inner_bg_position .';';
		if ( $inner_bg_repeat ) $inner_bg_css .= 'background-repeat:'. $inner_bg_repeat .';';
		if ( $inner_bg_size ) $inner_bg_css .= 'background-size:'. $inner_bg_size .';';
	}

	if ( $inner_bg_color_one ) {
		if ( $inner_bg_color_percent ) {
			$inner_bg_css .= sprintf( 'background-image: linear-gradient(%6$s, %1$s %5$s , %1$s %3$s , %2$s %4$s );',
				$inner_bg_color_one,
				$inner_bg_color_two,
				intval( $inner_bg_color_percent ) + 1 . '%',
				intval( $inner_bg_color_percent ) . '%',
				'0%',
				$inner_bg_direction
			);
		} else {
			$bg_css .= sprintf( 'background-image: linear-gradient(%3$s, %1$s, %2$s );',
				$inner_bg_color_one,
				$inner_bg_color_two,
				$inner_bg_direction
			);
		}
	}
	
	$content .= sprintf( '<div class="deeper-background row-inner %2$s" style="%1$s" data-inviewport="yes"></div>', $inner_bg_css, $inner_bg_cls );
}

$css_class = preg_replace( '/\s+/', ' ', apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, implode( ' ', array_filter( array_unique( $css_classes ) ) ), $this->settings['base'], $atts ) );
$wrapper_attributes[] = 'class="' . esc_attr( trim( $css_class ) ) . '"';

$output .= '<div ' . implode( ' ', $wrapper_attributes ) . '>';
$output .= wpb_js_remove_wpautop( $content );
$output .= '</div>';
$output .= $after_output;

return $output;
